# no-src spec, otherwise ~1.5GB will use for srpm
# surge-xt 1.0.0 released
# get source: git clone https://github.com/surge-synthesizer/surge -b release-xt/1.0.0
# get submodules: git submodule update --init --recursive
# for LV2-fork
# git clone --branch lv2 https://github.com/lv2-porting-project/JUCE JUCE-lv2
# then remove all ../libs/JUCE/* with ../JUCE-lv2/*
# cmake -Bignore/sxt -DCMAKE_BUILD_TYPE=Release -DCMAKE_INSTALL_PREFIX= -DJUCE_SUPPORTS_LV2=True
# cmake --build ignore/sxt --config Release --parallel 8

# to fix in files and install spaces in names make 
# install all in 


Summary:    Subtractive hybrid synthesizer virtual instrument
Name:       surge-xt
Version:    1.0.1
Release:    %mkrel 2
Group:      Sound
License:    GPL3
URL:        https://github.com/surge-synthesizer/surge
Source0:    SurgeLogo.png

BuildRequires:	cmake
BuildRequires:	desktop-file-utils
BuildRequires:	pkgconfig
BuildRequires:	pkgconfig(cairo)
BuildRequires:	pkgconfig(xkbcommon-x11)
BuildRequires:	pkgconfig(xcb-cursor)
BuildRequires:	pkgconfig(xcb-keysyms)
BuildRequires:	pkgconfig(xcb-util)
BuildRequires:	pkgconfig(xrandr)
BuildRequires:	pkgconfig(xinerama)
BuildRequires:	pkgconfig(xcursor)
BuildRequires:	lib64freetype6-devel
BuildRequires:	lib64python-devel
BuildRequires:	lib64sndio-devel
BuildRequires:  lib64sndfile-devel
BuildRequires:	lv2core-devel
BuildRequires:	ladspa-devel
BuildRequires:	lib64samplerate-devel
BuildRequires:	pkgconfig(libpulse)
BuildRequires:	pkgconfig(libpulse-simple)
BuildRequires:	pkgconfig(alsa)
BuildRequires:	pkgconfig(jack)
BuildRequires:	xdg-utils

BuildRoot:  %{_tmppath}/%{name}-%{version}-%{release}-buildroot

Provides: vst-plugin

%description
Subtractive hybrid synthesizer virtual instrument
Surge XT includes VST3 and LV2 instrument formats for use in
compatible hosts and a standalone executable


%prep
rm -rf %{_builddir}/surge
rm -rf %{_builddir}/JUCE-lv2

git clone https://github.com/surge-synthesizer/surge -b release-xt/%{version}

cd surge
git pull

git submodule update --init --recursive

cd ..
# # for LV2
git clone --branch lv2 https://github.com/lv2-porting-project/JUCE JUCE-lv2
rm -Rf %{_builddir}/surge/libs/JUCE/*
cp -fr %{_builddir}/JUCE-lv2/* %{_builddir}/surge/libs/JUCE/

%build
# from tex
CFLAGS+=' -fcommon'

cd surge
cmake -Bignore/sxt -DCMAKE_BUILD_TYPE=Linux -DCMAKE_INSTALL_PREFIX=/usr -DJUCE_SUPPORTS_LV2=True
cmake --build ignore/sxt --config Release --parallel 8


%install
rm -rf $RPM_BUILD_ROOT

install -m 0755 -d %{buildroot}%{_bindir}
install -m 0755 -d %{buildroot}%{_datadir}/applications
install -m 0755 -d %{buildroot}%{_datadir}
install -m 0755 -d %{buildroot}%{_defaultdocdir}/surge-xt
install -m 0755 -d %{buildroot}%{_libdir}/vst3
install -m 0755 -d %{buildroot}%{_libdir}/lv2
install -m 0755 -d %{buildroot}%{_datarootdir}/"Surge XT"

install -m 0644 %{_builddir}/surge/LICENSE %{buildroot}%{_defaultdocdir}/surge-xt/
install -m 0644 %{_builddir}/surge/README.md %{buildroot}%{_defaultdocdir}/surge-xt/
install -m 0644 %{_builddir}/surge/AUTHORS %{buildroot}%{_defaultdocdir}/surge-xt/

cp -r %{_builddir}/surge/resources/data/* %{buildroot}%{_datarootdir}/"Surge XT"/
cp -r %{_builddir}/surge/ignore/sxt/surge_xt_products/"Surge XT.vst3" %{buildroot}%{_libdir}/vst3/
cp -r %{_builddir}/surge/ignore/sxt/surge_xt_products/"Surge XT Effects.vst3" %{buildroot}%{_libdir}/vst3/
cp -r %{_builddir}/surge/ignore/sxt/surge_xt_products/"Surge XT.lv2" %{buildroot}%{_libdir}/lv2/
cp -r %{_builddir}/surge/ignore/sxt/surge_xt_products/"Surge XT Effects.lv2" %{buildroot}%{_libdir}/lv2/

# install executable files as executable
install -m 0755 %{_builddir}/surge/ignore/sxt/surge_xt_products/"Surge XT" %{buildroot}%{_bindir}/"Surge-XT"
install -m 0755 %{_builddir}/surge/ignore/sxt/surge_xt_products/"Surge XT Effects" %{buildroot}%{_bindir}/"Surge-XT-Effects"

# set permissions on shared libraries
find %{buildroot}%{_libdir}/vst3/ -type f -iname "*.so" -exec chmod 0644 {} +
find %{buildroot}%{_libdir}/lv2/ -type f -iname "*.so" -exec chmod 0644 {} +

# install desktop files
%__cat <<EOF > %{buildroot}%{_datadir}/applications/%{name}.desktop
[Desktop Entry]
Name=surge-xt
Comment=Digital Synthesizer
Exec=/usr/bin/Surge-XT
Icon=SurgeLogo
Terminal=false
Type=Application
Categories=GTK;Sound;X-MandrivaLinux-Multimedia-Sound;Audio;
Encoding=UTF-8
EOF

%__cat <<EOF > %{buildroot}%{_datadir}/applications/%{name}-effects.desktop
[Desktop Entry]
Name=surge-xt-effects
Comment=Effect-settings for Surge-XT
Exec=/usr/bin/Surge-XT-Effects
Icon=SurgeLogo
Terminal=false
Type=Application
Categories=GTK;Sound;X-MandrivaLinux-Multimedia-Sound;Audio;
Encoding=UTF-8
EOF

# Symlink icons into the right folders
install -d -m 0755 %{buildroot}%{_iconsdir}
for i in 16 22 24 32 48 72 96 128 256; do
install -d -m 0755 %{buildroot}%{_iconsdir}/hicolor/${i}x${i}/apps
install -m 0644 %{S:0} %{buildroot}%{_iconsdir}/hicolor/${i}x${i}/apps/SurgeLogo.png
convert -resize ${i}x${i} %{buildroot}%{_iconsdir}/hicolor/${i}x${i}/apps/SurgeLogo.png %{buildroot}%{_iconsdir}/hicolor/${i}x${i}/apps/SurgeLogo.png
done


%clean
rm -rf $RPM_BUILD_ROOT

%post
gtk-update-icon-cache /usr/share/icons/hicolor/ 
/sbin/ldconfig
%update_menus

%postun
%clean_menus


%files
%{_bindir}/Surge-*
%{_libdir}/vst3/Surge*.vst3
%{_libdir}/lv2/Surge*.lv2
%{_datarootdir}/Surge*XT/*
/usr/share/doc/surge-xt/AUTHORS
/usr/share/doc/surge-xt/LICENSE
/usr/share/doc/surge-xt/README.md
%{_datadir}/applications/*.desktop
%{_iconsdir}/hicolor/*/apps/SurgeLogo.png


%changelog
* Fri Mar 29 2022 onkelho <oh.quait at gmail.com> - 1.0.1-2pclos2022
- rebuild 
- fix menus and icon refresh

* Sun Feb 06 2022 onkelho <oh.quait at gmail.com> - 1.0.1-1pclos2022
- new version released 2022-01-31

* Wed Jan 26 2022 onkelho <oh.quait at gmail.com> - 1.0.0-2pclos2022
- rebuild
- - CFLAGS+=' -fcommon'

* Sun Jan 23 2022 onkelho <oh.quait at gmail.com> - 1.0.0-1pclos2022
- mkruselj Update Luna's patches (#5781) 1edd725 5 days ago
- move too JUCE-lv2 for build vst3 and lv2 

